/******************************************************************************/
/*                                                                            */
/* Project Description :                                                      */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/* System Name :                                                              */
/*   File Name : toolmgr.c                                                    */
/*     Summary :                                                              */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/* Create by : Pony Chiang                                                    */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*                             MiTAC (R) V 1.00                               */
/*                     Copyright (C) Version2 Inc. 2001                       */
/*                            All right reserved.                             */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/* Update History :                                                           */
/*   Mark  |      Date      |     Name    |   Description                     */
/*---------|----------------|-------------|-----------------------------------*/
/*         |                |             |                                   */
/*---------|----------------|-------------|-----------------------------------*/
/*         |                |             |                                   */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*  Functions :                                                               */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*  Parameter description :                                                   */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/* Include File :                                                             */
#include "dttx.h"

/******************************************************************************/
/* Main Function                                                              */
/******************************************************************************/
int main (int argc, char *argv[])
{
    if (argc < 2)
    {
        printf ("Usage :\n");
        printf ("dttx [Date Time]\n");
        exit (0);
    }

    db_OpenDB ();
    o_loginDB ();

    memset (NowDt, 0x00, sizeof (char[15]));
    C_NowDateTime (NowDt);

    memset (sqlstr, 0x00, sizeof (char[2048]));
    sprintf (sqlstr, "SELECT COUNT(serial_number) FROM mitac."\
                     "v_tp_sn_production_log_mi WHERE in_station_time "\
                     "BETWEEN TO_DATE('%s','YYYYMMDDHH24MISS') AND "\
                     "TO_DATE('%s','YYYYMMDDHH24MISS') AND station_number in "\
                     "(600000178,600000179,600000180,600000181,600000158,"\
                     "600000159,600000182,600000183,600000184,600000185,"\
                     "600000186,600000187,600000188,600000189,600000190,"\
                     "600000191,600000192,600000193,600000194,600000195,"\
                     "600000196,600000197,600000198,600000199,600000088,"\
                     "600000089,600000090,600000091,600000116,600000117,"\
                     "600000118,600000092,600000093,600000094,600000095,"\
                     "600000096,600000097,600000098,600000099,600000100,"\
                     "600000101,600000102,600000103,600000104,600000105,"\
                     "600000106,600000107,600000108,600000109,600000030,"\
                     "600000031,600000032,600000033,600000034,600000035,"\
                     "600000036,600000037,600000038,600000039,600000040,"\
                     "600000041,600000042,600000043,600000044,600000045,"\
                     "600000046,600000047,600000126,600000127,600000128,"\
                     "600000129,600000130,600000048,600000049,600000050,"\
                     "600000051,600000052,600000053,600000054,600000055,"\
                     "00000056,600000057,600000058,600000059,600000066,"\
                     "600000067,600000068,600000069,600000070) ORDER BY "\
                     "in_station_time", argv[1], NowDt);

    dtttl = 0;
    dtttl = o_ReturnInteger (sqlstr);
    printf ("dtttl=(%d)\n", dtttl);

    if (dtttl > 0)
    {
        ttlsize = dtttl * sizeof (MESDT);
        mesdt = (MESDT *) malloc (ttlsize);
        memset (mesdt, 0x00, ttlsize);

        memset (sqlstr, 0x00, sizeof (char[2048]));
        sprintf (sqlstr, "SELECT serial_number,model_name,mo_number,"\
                         "TO_CHAR(station_number) AS sno,fork_flag,"\
                         "TO_CHAR(in_station_time,'YYYYMMDDHH24MISS') FROM "\
                         "mitac.v_tp_sn_production_log_mi WHERE "\
                         "in_station_time BETWEEN TO_DATE('%s',"\
                         "'YYYYMMDDHH24MISS') AND TO_DATE('%s',"\
                         "'YYYYMMDDHH24MISS') and station_number in "\
                         "(600000178,600000179,600000180,600000181,600000158,"\
                         "600000159,600000182,600000183,600000184,600000185,"\
                         "600000186,600000187,600000188,600000189,600000190,"\
                         "600000191,600000192,600000193,600000194,600000195,"\
                         "600000196,600000197,600000198,600000199,600000088,"\
                         "600000089,600000090,600000091,600000116,600000117,"\
                         "600000118,600000092,600000093,600000094,600000095,"\
                         "600000096,600000097,600000098,600000099,600000100,"\
                         "600000101,600000102,600000103,600000104,600000105,"\
                         "600000106,600000107,600000108,600000109,600000030,"\
                         "600000031,600000032,600000033,600000034,600000035,"\
                         "600000036,600000037,600000038,600000039,600000040,"\
                         "600000041,600000042,600000043,600000044,600000045,"\
                         "600000046,600000047,600000126,600000127,600000128,"\
                         "600000129,600000130,600000048,600000049,600000050,"\
                         "600000051,600000052,600000053,600000054,600000055,"\
                         "00000056,600000057,600000058,600000059,600000066,"\
                         "600000067,600000068,600000069,600000070) ORDER BY "\
                         "in_station_time", argv[1], NowDt);
        turncnt = ReadMES (mesdt, sqlstr, dtttl);

        if (turncnt == dtttl)
        for (li=0; li<dtttl; li++)
        {
            memset (sqlstr, 0x00, sizeof (char[2048]));
            TrimStr (mesdt[li].s_no, sqlstr, 0);
            memset (mesdt[li].s_no, 0x00, sizeof (char[26]));
            sprintf (mesdt[li].s_no, "%s", sqlstr);

            memset (sqlstr, 0x00, sizeof (char[2048]));
            TrimStr (mesdt[li].ModeName, sqlstr, 0);
            memset (mesdt[li].ModeName, 0x00, sizeof (char[41]));
            sprintf (mesdt[li].ModeName, "%s", sqlstr);

            memset (sqlstr, 0x00, sizeof (char[2048]));
            TrimStr (mesdt[li].MoNo, sqlstr, 0);
            memset (mesdt[li].MoNo, 0x00, sizeof (char[26]));
            sprintf (mesdt[li].MoNo, "%s", sqlstr);

            memset (sqlstr, 0x00, sizeof (char[2048]));
            TrimStr (mesdt[li].sno, sqlstr, 0);
            memset (mesdt[li].sno, 0x00, sizeof (char[11]));
            sprintf (mesdt[li].sno, "%s", sqlstr);

            printf ("\nmesdt[%d].SerialNo=[%s]\n", li+1, mesdt[li].s_no);
            printf ("mesdt[%d].ModeName=[%s]\n", li+1, mesdt[li].ModeName);
            printf ("mesdt[%d].MoNo=    [%s]\n", li+1, mesdt[li].MoNo);
            printf ("mesdt[%d].sno=     [%s]\n", li+1, mesdt[li].sno);
            printf ("mesdt[%d].ForkFlag=(%d)\n", li+1, mesdt[li].ForkFlag);
            printf ("mesdt[%d].DateTime=[%s]\n", li+1, mesdt[li].DateTime);
            printf ("-----------------------------------------\n");

            memset (sqlstr, 0x00, sizeof (char[2048]));
            sprintf (sqlstr,"INSERT INTO mestable (orderno,pattern,serial,"\
                            "station,forkflag,stationtime) VALUES ('%s',"\
                            "'%s','%s','%s',%d,TO_TIMESTAMP('%s',"\
                            "'YYYYMMDDHH24MISS'))",
                            mesdt[li].ModeName, mesdt[li].MoNo,mesdt[li].s_no,
                            mesdt[li].sno, mesdt[li].ForkFlag, 
                            mesdt[li].DateTime);
            SQLExe (sqlstr);
            printf ("Writed to PostgreSQL!\n");
        }
        else
        printf ("Data count error !\n");

        printf ("Data Total (%d)\n", dtttl);

        free (mesdt);
    }
    
    db_CloseDB ();
    o_logoutDB();

    exit (0);
}
